<?php
/*
Plugin Name: Delay Print CSS
Plugin URI: http://bigredtin.com/plugins/delay-print-css/
Description: Prevent your print stylesheets from delaying rendering of your website
Author: Peter Wilson
Version: 0.1
Requires at least: 2.8
Author URI: http://peterwilson.cc/
License: GPL
*/


if ( ! class_exists( 'BRT_PrintCSS' ) ) {
	class BRT_PrintCSS {
		
		
		var $jsOutput = '';
		
		/* PHP 4 Constructor */
		function BRT_PrintCSS(){$this->__construct();}
		
		/* PHP 5 */
		function __construct(){
			add_filter('style_loader_tag', array(&$this, 'printCss'), 5, 2); /* WP 2.6 */
			add_action('wp_footer', array(&$this, 'outputJS')); /* 1.5 */
		}
		
		function printCss($tag, $handle) {
			global $wp_styles;
			
			if ($wp_styles->registered[$handle]->args == 'print') {
				//delay this stylesheet
				
				$tag = "<noscript>\n" . $tag . "</noscript>\n";
				
				
				//extract the URL
				preg_match("/<\s*link\s+[^>]*href\s*=\s*[\"']?([^\"' >]+)[\"' >]/", $tag, $match);
			    $href = $match[1];
			
				//check for conditionals
				//SRC: wp-includes/class.wp-styles.php
				if ( isset($wp_styles->registered[$handle]->extra['conditional']) && 
					 $wp_styles->registered[$handle]->extra['conditional'] ) {
						
					$jsOutput .= "<!--[if {$wp_styles->registered[$handle]->extra['conditional']}]>\n";
					$end_cond = "<![endif]-->\n";
				}
				else {
					$end_cond = "\n";
				}
				
				
				$jsOutput .= "<script type='text/javascript'>//<![CDATA[\n";
				
				$jsOutput .= "brt_print.add('" . esc_js($href) . "','" . esc_js($handle) ."');";
					
				/*	
					function(){";
				$jsOutput .= "var d=document,c=d.createElement('link');";
				$jsOutput .= "c.type='text/css';";
				$jsOutput .= "c.rel='stylesheet';";
				$jsOutput .= "c.id='" . esc_js($handle) . "';";
				$jsOutput .= "c.href='" . esc_js($href) . "';";
				$jsOutput .= "c.media='print';";
				$jsOutput .= "d.getElementsByTagName(\"head\")[0].appendChild(c);";
				//$jsOutput .= "console.log('" . esc_js($handle) . "');";
				$jsOutput .= "});";
				*/
				$jsOutput .= "\n//]]></script>";
				$jsOutput .= $end_cond;
				$end_cond = '';	
				
				$this->jsOutput .= $jsOutput;
			}
			
			return $tag;
		}
		
		
		function outputJS(){
			$jsOutput = $this->jsOutput;
			if ( (isset($jsOutput)) && (trim($jsOutput) != '')) {
				if (wp_script_is('jquery','done') == true) { /* WP 2.8 */
					echo "<script type='text/javascript'>//<![CDATA[\n";
					//echo "function brt_addWinLoad(f){jQuery('window').ready(f);}";
					

					echo <<<EOF
					brt_print = function(){
						var $ = jQuery,
							DOC = document,
							cssNode = DOC.createElement('link');
							
						cssNode.type='text/css';
						cssNode.rel='stylesheet';
						cssNode.media='print';
						
						function add(url, handle){
							$(window).ready(function(){
								cssNode.href= url;
								cssNode.id  = handle;
								DOC.getElementsByTagName('head')[0].appendChild(cssNode);								
							});
						}
						
						return{add:add}
						
					}();
EOF;
					
					
					echo "\n//]]></script>";
				}
				else {
					echo "<script type='text/javascript'>//<![CDATA[\n";	
					
					echo <<<EOF
					
					brt_print=function(){
						var sheets=[],
							DOC=document,
							WIN=window,
							cssNode=DOC.createElement('link'),
							event='load',
							onevent='on'+event;
							
						cssNode.type='text/css';
						cssNode.rel='stylesheet';
						cssNode.media='print';
						
						function add(url, handle){
							sheets.push(function(){
								cssNode.href= url;
								cssNode.id  = handle;
								DOC.getElementsByTagName('head')[0].appendChild(cssNode);
							});
						}
						
						function doinit(){
							for(var i=0;i<sheets.length;i++){
								sheets[i]();
							}
						}
						
						if (WIN.addEventListener) {
							WIN.addEventListener(event,doinit,false);
						}
						else if(WIN.attachEvent){
							WIN.attachEvent(onevent,doinit);
						}
						else {
							var oldonload = WIN.onload;
							if (typeof WIN.onload != 'function') {
								WIN.onload = doinit;
							}
							else {
								WIN.onload = function(){
									if (oldonload) {
										oldonload();
									}
									doinit();
								}
							}
						}
						
						return{add:add}
					}();
					
EOF;
					/*
					//
					// Needs redoing with YUI Compressor
					//
					echo "brt_print=function(){var f=[],a=window,d='load',h='on'+d;";
					echo "function c(e){f.push(e)}function b(){for(var e=0;e<f.length;e++)";
					echo "{f[e]()}}if(a.addEventListener){a.addEventListener(d,b,false)}else";
					echo "{if(a.attachEvent){a.attachEvent(h,b)}else{var g=a.onload;if(typeof "; 
					echo "a.onload!='function'){a.onload=b}else{a.onload=function(){";
					echo "if(g){g()}b()}}}}return{add:c}}();";
					*/
					echo "\n//]]></script>";
				}
				echo $jsOutput;
			}
		}
		
	} //class BRT_PrintCSS
	
	$brtPrintCSS = new BRT_PrintCSS();
} //if ( ! class_exists( 'BRT_PrintCSS' ) )

?>